<template>
    <el-dialog :title="form.id ? '编辑' : '新增'" v-model="visible"
      :close-on-click-modal="false" draggable>
      <el-form ref="dataFormRef" :model="form" :rules="dataRules" formDialogRef label-width="90px" v-loading="loading">
       <el-row :gutter="24">
    <el-col :span="24" class="mb20">
      <el-form-item label="创建人" prop="createBy">
        <el-input v-model="form.createBy" placeholder="请输入创建人"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="创建时间" prop="createTime">
        <el-input v-model="form.createTime" placeholder="请输入创建时间"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="更新人" prop="updateBy">
        <el-input v-model="form.updateBy" placeholder="请输入更新人"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="更新时间" prop="updateTime">
        <el-input v-model="form.updateTime" placeholder="请输入更新时间"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="删除标记" prop="delFlag">
        <el-input v-model="form.delFlag" placeholder="请输入删除标记"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="租户ID" prop="tenantId">
        <el-input v-model="form.tenantId" placeholder="请输入租户ID"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="备注" prop="REMARKS">
        <el-input v-model="form.remarks" placeholder="请输入备注"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="学年" prop="schoolYear">
        <el-input v-model="form.schoolYear" placeholder="请输入学年"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="学期" prop="schoolTerm">
        <el-input v-model="form.schoolTerm" placeholder="请输入学期"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="标题" prop="TITLE">
        <el-input v-model="form.title" placeholder="请输入标题"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="内容" prop="CONTENT">
        <el-input v-model="form.content" placeholder="请输入内容"/>
      </el-form-item>
      </el-col>

    <el-col :span="24" class="mb20">
      <el-form-item label="作者" prop="AUTHOR">
        <el-input v-model="form.author" placeholder="请输入作者"/>
      </el-form-item>
      </el-col>

			</el-row>
      </el-form>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="visible = false">取 消</el-button>
          <el-button type="primary" @click="onSubmit" :disabled="loading">确 认</el-button>
        </span>
      </template>
    </el-dialog>
</template>

<script setup lang="ts" name="WeekPlanDialog">
import { useDict } from '/@/hooks/dict';
import { useMessage } from "/@/hooks/message";
import { getObj, addObj, putObj, validateExist } from '/@/api/stuwork/weekPlan'
import { rule } from '/@/utils/validate';
const emit = defineEmits(['refresh']);

// 定义变量内容
const dataFormRef = ref();
const visible = ref(false)
const loading = ref(false)
// 定义字典

// 提交表单数据
const form = reactive({
		id:'',
	  createBy: '',
	  createTime: '',
	  updateBy: '',
	  updateTime: '',
	  delFlag: '',
	  tenantId: '',
	  REMARKS: '',
	  schoolYear: '',
	  schoolTerm: '',
	  title: '',
	  content: '',
	  author: '',
});

// 定义校验规则
const dataRules = ref({
})

// 打开弹窗
const openDialog = (id: string) => {
  visible.value = true
  form.id = ''

  // 重置表单数据
	nextTick(() => {
		dataFormRef.value?.resetFields();
	});

  // 获取weekPlan信息
  if (id) {
    form.id = id
    getWeekPlanData(id)
  }
};

// 提交
const onSubmit = async () => {
	const valid = await dataFormRef.value.validate().catch(() => {});
	if (!valid) return false;

	try {
    loading.value = true;
		form.ID ? await putObj(form) : await addObj(form);
		useMessage().success(form.ID ? '修改成功' : '添加成功');
		visible.value = false;
		emit('refresh');
	} catch (err: any) {
		useMessage().error(err.msg);
	} finally {
    loading.value = false;
  }
};


// 初始化表单数据
const getWeekPlanData = (id: string) => {
  // 获取数据
  loading.value = true
  getObj({ID: id}).then((res: any) => {
    Object.assign(form, res.data[0])
  }).finally(() => {
    loading.value = false
  })
};

// 暴露变量
defineExpose({
  openDialog
});
</script>
